local AceOO = AceLibrary("AceOO-2.0")

Addon = AceOO.Class(ShakedownAddonBase)

Addon.prototype.number = 5
Addon.prototype.localID = "Shakedown CandyBar %d"
Addon.prototype.realID = "HotCandy%s"

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "HotCandy", "Hot Candy")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end

    -- create paused bars, in the same manner as HotCandy:TestBars
    local localID = nil
    local addonID = nil
    for i = 1, self.number do
        localID = string.format(self.localID, i)
        addonID = string.format(self.realID, localID)
        HotCandy:ShowCandyBar(localID, 2+(i*2), "Interface\\Icons\\Spell_Holy_Renew", "green", "yellow", "orange", "red") -- this is the HotCandy method, NOT the CandyBar method
        HotCandy:PauseCandyBar(addonID)
    end

end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- kill each of the bars; no need to unregister because set and forget was specified by HotCandy:ShowCandyBar
    local localID = nil
    local addonID = nil
    for i = 1, self.number do
        localID = string.format(self.localID, i)
        addonID = string.format(self.realID, localID)
        HotCandy:StartCandyBar(addonID)
        HotCandy:SetCandyBarTimeLeft(addonID, 0)
        HotCandy:SetCandyBarFade(addonID, 0)
    end

end

-- create the instance of this class
local thisAddon = Addon:new()